]> git.lyx.org Git - lyx.git/blobdiff - autogen.sh
bug 1825 make sure that we do not return a pos that is not on the row
[lyx.git] / autogen.sh
index cd49ec6ed4557334832b8a2890351d388d6aad66..36710855fb045cbe59be54a49ff097deecb07c70 100755 (executable)
@@ -1,63 +1,85 @@
 #!/bin/sh
 
+ACLOCAL="aclocal -I ${PWD}/m4"
+AUTOHEADER="autoheader"
+AUTOMAKE="automake -a -c --foreign"
+AUTOCONF="autoconf"
+ACINCLUDE_FILES="lyxinclude.m4 libtool.m4 xforms.m4 qt.m4 gtk--.m4 gnome--.m4 gnome.m4 spell.m4 cygwin.m4 pkg.m4"
+
+# Discover what version of automake we are using.
+automake_version=`$AUTOMAKE --version 2>/dev/null | head -n 1`
+
+test "$automake_version" != "" && {
+    echo "Using $automake_version"
+} || {
+    echo "LyX requires automake >= 1.5"
+    exit 1
+}
+
+case $automake_version in
+    *' '1.[5-9]*)
+       ;;
+    *)
+    
+       echo "This automake version is not supported by LyX."
+        echo "LyX only supports automake 1.[5-9]."
+        exit 1
+        ;;
+esac
+                                                       
 # Discover what version of autoconf we are using.
-autoversion=`autoconf --version | head -n 1`
+autoversion=`$AUTOCONF --version 2>/dev/null | head -n 1`
 
+test "$autoversion" != "" && {
+    echo "Using $autoversion"
+} || {
+    echo "LyX requires autoconf >= 2.52"
+    exit 1
+}
+           
 case $autoversion in
-    *2.13)
-       cp config/acconfig.h .
-       cp config/configure.in .
-       rm -f configure.ac
-       cp config/relyx_configure.in lib/reLyX/configure.in
-       rm -f lib/reLyX/configure.ac
-       ;;
-    *2.5[23])
-       rm -f acconfig.h
-       rm -f configure.in
-       cp config/configure.ac .
-       rm -f lib/reLyX/configure.in
-       cp config/relyx_configure.ac lib/reLyX/configure.ac
+    *' '2.5[2-9])
+       EXTRA_ACINCLUDE_FILES="lyxinclude25x.m4"
        ;;
     *)
-       echo "You are running autoconf $autoversion, that"
-       echo "version is not supported by LyX."
-       echo "LyX only supports autoconf 2.13 and 2.53."
-       exit
+       echo "This autoconf version is not supported by LyX."
+       echo "LyX only supports autoconf 2.5[2-9]."
+       exit 1
        ;;
 esac
 
-
-ACLOCAL=aclocal
-AUTOHEADER="autoheader"
-AUTOMAKE="automake -a -c --foreign"
-AUTOCONF="autoconf"
+echo -n "Locating GNU m4... "
 GNUM4=
+for prog in $M4 gm4 gnum4 m4; do
+       # continue if $prog generates error (e.g. does not exist)
+       ( $prog --version ) < /dev/null > /dev/null 2>&1
+       if test $? -ne 0 ; then continue; fi
 
-ACINCLUDE_FILES="lyxinclude.m4 libtool.m4 codeset.m4 gettext.m4 glibc21.m4 iconv.m4 isc-posix.m4 lcmessage.m4 progtest.m4 xforms.m4 qt.m4 gtk--.m4 gnome--.m4 gnome.m4 pspell.m4 pkg.m4"
-SIGCPP_ACINCLUDE_FILES="libtool.m4"
-
-echo -n "Locating GNU m4... "
-for prog in $M4 gm4 gnum4 m4 ; do
-  case `$prog --version 2>&1` in
-    *GNU*) ok=yes
-          GNUM4=$prog
-          echo "found: $GNUM4"
-          break ;;
-    *) ;;
-  esac
+       # /dev/null input prevents a hang of the script for some m4 compilers (e.g. on FreeBSD)
+       case `$prog --version < /dev/null 2>&1` in
+       *GNU*)  GNUM4=$prog
+               break ;;
+       esac
 done
-if test x$ok != xyes ; then
-    echo "not found."
+if test x$GNUM4 = x ; then
+       echo "not found."
+       exit 1
+else
+       echo `which $GNUM4`
 fi
 
+# Delete old cache directories.
+# automake will stop if their contents was created by an earlier version.
+rm -rf autom4te.cache lib/reLyX/autom4te.cache
+
 # Generate acinclude.m4
 echo -n "Generate acinclude.m4... "
 rm -f acinclude.m4
-(cd config ; cat ${ACINCLUDE_FILES} >../acinclude.m4)
+(cd config ; cat ${ACINCLUDE_FILES} ${EXTRA_ACINCLUDE_FILES} >../acinclude.m4)
 echo "done."
 
 # Generate the Makefiles and configure files
-if ( $ACLOCAL --version ) </dev/null > /dev/null 2>&1; then
+if ( $ACLOCAL --version ) < /dev/null > /dev/null 2>&1; then
        echo "Building macros..."
        for dir in . lib/reLyX ; do
            echo "        $dir"
@@ -66,10 +88,10 @@ if ( $ACLOCAL --version ) </dev/null > /dev/null 2>&1; then
        echo "done."
 else
        echo "aclocal not found -- aborting"
-       exit
+       exit 1
 fi
 
-if ( $AUTOHEADER --version ) </dev/null > /dev/null 2>&1; then
+if ( $AUTOHEADER --version ) < /dev/null > /dev/null 2>&1; then
        echo "Building config header template..."
        for dir in . ; do
            echo "        $dir"
@@ -78,10 +100,10 @@ if ( $AUTOHEADER --version ) </dev/null > /dev/null 2>&1; then
        echo "done."
 else
        echo "autoheader not found -- aborting"
-       exit
+       exit 1
 fi
 
-if ( $AUTOMAKE --version ) </dev/null > /dev/null 2>&1; then
+if ( $AUTOMAKE --version ) < /dev/null > /dev/null 2>&1; then
        echo "Building Makefile templates..."
        for dir in . lib/reLyX ; do
            echo "        $dir"
@@ -90,10 +112,10 @@ if ( $AUTOMAKE --version ) </dev/null > /dev/null 2>&1; then
        echo "done."
 else
        echo "automake not found -- aborting"
-       exit
+       exit 1
 fi
 
-if ( $AUTOCONF --version ) </dev/null > /dev/null 2>&1; then
+if ( $AUTOCONF --version ) < /dev/null > /dev/null 2>&1; then
        echo "Building configure..."
        for dir in . lib/reLyX ; do
            echo "       $dir"
@@ -102,20 +124,15 @@ if ( $AUTOCONF --version ) </dev/null > /dev/null 2>&1; then
        echo "done."
 else
        echo "autoconf not found -- aborting"
-       exit
+       exit 1
 fi
 
 # Autogenerate lib/configure.m4.
-if test x$GNUM4 != x ; then
-    echo -n "Building lib/configure ... "
-    rm -f lib/configure
-    $GNUM4 lib/configure.m4 > lib/configure
-    chmod a+x lib/configure
-    echo "done."
-else
-    echo "No GNU m4. Impossible to build lib/configure -- aborting"
-    exit
-fi
+echo -n "Building lib/configure ... "
+rm -f lib/configure
+$GNUM4 lib/configure.m4 > lib/configure
+chmod a+x lib/configure
+echo "done."
 
 echo
 echo 'run "./configure ; make"'